/* Include/config_nws.h.  Generated automatically by configure.  */
/* $Id: config_nws.h.in,v 1.23 2004/08/19 23:44:37 graziano Exp $ */

#ifndef CONFIG_H
#define CONFIG_H

#include <stdlib.h>

#ifdef __cplusplus
extern "C" {
#endif

#ifndef NULL
#  define NULL 0
#endif

/* NWS version number */
#define VERSION "2.11"

/* Preserve 2.0 interface with this definition */
/* #undef NWS_API_COMPAT */

/* Define if you have the sys/statfs.h header.  */
#define HAVE_SYS_TYPES_H 1
#ifdef HAVE_SYS_TYPES_H
#include <sys/types.h>
#endif

/* Define to `int' if <sys/types.h> doesn't define.  */
/* #undef pid_t */

/* Define if you have the alarm function.  */
#define HAVE_ALARM 1

/* Define if you have the getrusage function.  */
#define HAVE_GETRUSAGE 1

/* Define if you have the sighold function.  */
#define HAVE_SIGHOLD 1

/* Define if you have the sigrelse function.  */
#define HAVE_SIGRELSE 1

/* Define if you have the statvfs function.  */
#define HAVE_STATVFS 1

/* Define if you have the sys/vfs.h header.  */
#define HAVE_SYS_VFS_H 1

/* Define if you have the sys/statfs.h header.  */
#define HAVE_SYS_STATFS_H 1

/* Define if you have the sys/param.h header.  */
#define HAVE_SYS_PARAM_H 1

/* Define if you have the sys/mount.h header.  */
#define HAVE_SYS_MOUNT_H 1

/* Define if you have the dirent.h & Co. header.  */
#define HAVE_DIRENT_H 1
/* #undef HAVE_SYS_NDIR_H */
/* #undef HAVE_SYS_DIR_H */
/* #undef HAVE_NDIR_H */


/* Define if you have the utmp.h header.  */
#define HAVE_UTMP_H 1

/* Define if you have the utmpx.h header.  */
#define HAVE_UTMPX_H 1

/* define if time.h and sys/time.h can be both included */
#define TIME_WITH_SYS_TIME 1
#define HAVE_SYS_TIME_H 1

/* pthread header is present */
/* #undef HAVE_PTHREAD_H */

/* define if sys/resource.h is present */
#define HAVE_SYS_RESOURCE_H 1

/* define if sys/resource.h is present */
#define HAVE_LIMITS_H 1

/* look for the postgresql include and library */
/* #undef HAVE_LIPQ_FE_H */
/* #undef HAVE_POSTGRESQL_LIBPQ_FE_H */
/* #undef HAVE_LIBPQ */
#if defined(HAVE_LIBPQ) && (defined(HAVE_POSTGRESQL_LIBPQ_FE_H) || defined(HAVE_LIBPQ_FE_H))
#	define NWS_WITH_DB
#endif

/* Define if you have getutent function.  */
#define HAVE_GETUTENT 1

/* Define if you have getutxent function.  */
#define HAVE_GETUTXENT 1

/* Define if you have the sysconf function.  */
#define HAVE_SYSCONF 1

/* Define if you have strcasecmp */
#define HAVE_STRCASECMP 1
#ifdef HAVE_STRCASECMP
int
strcasecmp(const char*, const char *);
#endif

/* Define if you have strbcasecmp */
#define HAVE_STRNCASECMP 1
#ifdef HAVE_STRNCASECMP
#include <stdlib.h>
int
strncasecmp(const char*, const char *, size_t n);
#endif

/* Define if you have the getpgid function.  */
#define HAVE_GETPGID 1
#ifdef HAVE_GETPGID
#include <unistd.h>
pid_t
getpgid(pid_t);
#endif

/* Define if we have opendir */
/* #undef HAVE_OPENDIR */

/* Define if we have readdir */
/* #undef HAVE_READDIR */

/* Define to the (char *) version of the NWS sources. */
#define VERSION "2.11"

/* Define as the path to the `uptime' program. */
#define UPTIME_PATH "/usr/bin/uptime"

/* Define as the path to the `vmstat' program. */
#define VMSTAT_PATH "/usr/bin/vmstat"

/* use the experimental sensors */
/* #undef EXPERIMENTAL */

/* we are compiling with debug options */
#define WITH_DEBUG 1

/* where PS is */
#define PS "/bin/ps"

/* where netlogger is */
/* #undef WITH_NETLOGGER */

#ifndef MALLOC
#	define MALLOC(size) malloc ((size)==0?1:(size))
#endif

#ifndef FREE
#	define FREE(ptr) \
	if (ptr != NULL) { \
		free(ptr); \
		ptr = NULL; \
	}
#endif

#ifdef __cplusplus
}
#endif

#endif
