/* Include/config_portability.h.  Generated automatically by configure.  */
/* $Id: config_portability.h.in,v 1.25 2004/08/20 20:45:23 graziano Exp $ */

#ifndef CONFIG_PORTABILITY_H
#define CONFIG_PORTABILITY_H

#include <stdlib.h>		/* free & malloc */

#ifdef __cplusplus
extern "C" {
#endif

#ifndef NULL
#  define NULL 0
#endif

/* Define to the (char *) version of the NWS sources. */
/* #undef VERSION */

/* Preserve 2.0 interface with this definition */
/* #undef NWS_API_COMPAT */

/* Define if we are going to use SIGALRM for our purposes */
#define USE_ALARM_SIGNAL 1

/* define which return type signal() wants */
#define RETSIGTYPE void

/* Define if non-blocking calls will be used */
/* #undef USE_NONBLOCKING */

/* Define if we are to use the experimental forecasters */
/* #undef EXPERIMENTAL_FORECASTS */

/* Have standard C headers. */
#define STDC_HEADERS 1

/* Define to `int' if <sys/types.h> doesn't define.  */
/* #undef pid_t */

/* Define if you have the sys/vfs.h header.  */
/* #undef HAVE_SYS_VFS_H */

/* Define if you have the sys/wait.h header.  */
#define HAVE_SYS_WAIT_H 1

/* Define if you have the math.h header.  */
#define HAVE_MATH_H 1

/* Define if you have the sys/time.h header.  */
#define HAVE_SYS_TIME_H 1

/* Define is time.h and sys/time.h can be both included */
#define TIME_WITH_SYS_TIME 1

/* Define if you have the sys/types.h header.  */
#define HAVE_UNISTD_H 1

/* Define if you have the sys/types.h header.  */
#define HAVE_SYS_TYPES_H 1

/* Define if you have the inttypes.h header.  */
#define HAVE_INTTYPES_H 1

/* Define if we have netinet/in.h */
#define HAVE_NETINET_IN_H 1

/* Define if we have fcntl.h */
#define HAVE_FCNTL_H 1

/* Define if we have select.h */
/* #undef HAVE_SELECT_H */

/* Define if we have sys/utsname.h */
#define HAVE_SYS_UTSNAME_H 1

/* Define if we have strdlib.h */
#define HAVE_STDLIB_H 1

/* Define if we have limits.h */
#define HAVE_LIMITS_H 1

/* Define to the type pointed to by the third parameter of getpeername(). */
#define SOCKLEN_T socklen_t

/* define if we have uint32_t */
#ifdef HAVE_INTTYPES_H
#	include <inttypes.h>
#endif
#ifdef HAVE_SYS_TYPES_H
#	include <sys/types.h>
#endif
#define UINT32_T uint32_t

struct IPADDRESS_TYPE {
#ifdef UINT32_T
	UINT32_T	addr;
#else
/* we couldn't find anything: let's do something very weird and hope for
 * the best: at least it works on CRAY SV1 */
	unsigned long	addr:32;
#endif
};

/* Define if you have the sysconf function.  */
#define HAVE_SYSCONF 1

/* Define if you have the strnlen function.  */
#define HAVE_STRNLEN 1

/* Define if you have the strtol function.  */
#define HAVE_STRTOL 1

/* Define if you have the strnlen function.  */
#define HAVE_STRCASECMP 1
#ifdef HAVE_STRCASECMP
int
strcasecmp(const char*, const char *);
#endif

/* Define if you have the alarm function.  */
#define HAVE_ALARM 1

/* Define if you have inet_ntoa */
#define HAVE_INET_ATON 1

/* Define if you have inet_ntoa */
#define HAVE_INET_NTOA 1

/* Define if you have the fileno function.  */
#define HAVE_FILENO 1

/* Define if you have gettimeofday */
#define HAVE_GETTIMEOFDAY 1

/* Define if you have gethostname. Some OSes doesn't have the definition
 * in the include: define it here to avoid warning message. */
#define HAVE_GETHOSTNAME 1
#ifdef HAVE_GETHOSTNAME
int
gethostname();  
#endif

/* Define if you have uname */
#define HAVE_UNAME 1

/* Define if you have gethostbyname */
#define HAVE_GETHOSTBYNAME 1

/* Define if you have gethostbyaddr */
#define HAVE_GETHOSTBYADDR 1

/* Define if you have gethostbyaddr */
#define HAVE_GETHOSTBYADDR_R 1

/* Define if you have the getrusage function.  */
#define HAVE_GETRUSAGE 1

/* Define if you have the sqrt function.  */
#define HAVE_SQRT 1

/* Define if we have fcntl */
#define HAVE_FCNTL 1

/* Define if we have select */
#define HAVE_SELECT 1

/* Define if you have the sighold function.  */
#define HAVE_SIGHOLD 1

/* Define if you have the sigrelse function.  */
#define HAVE_SIGRELSE 1

/* Define if you have the siginterrupt function.  */
#define HAVE_SIGINTERRUPT 1

/* Define if you have the statvfs function.  */
/* #undef HAVE_STATVFS */

/* Define if we have waitpid */
#define HAVE_WAITPID 1

/* Define if we have realloc */
#define HAVE_REALLOC 1

/* Define if we have uname */
#define HAVE_UNAME 1

/* Define as the path to the `uptime' program. */
/* #undef UPTIME_PATH */

/* Define as the path to the `vmstat' program. */
/* #undef VMSTAT_PATH */

/* do we have the pthread header? (and hopefully pthread support) */
/* #undef HAVE_PTHREAD_H */
#ifdef HAVE_PTHREAD_H
#	ifndef _REENTRANT
#		define _REENTRANT 1
#	endif
#endif

/* #undef PS */

/* #undef AWK */

/* #undef WITH_NETLOGGER */

#define MALLOC(size) malloc ((size)==0?1:(size))

#define FREE(ptr) \
        if (ptr != NULL) { \
		free(ptr); \
		ptr = NULL; \
	}


#ifdef __cplusplus
}
#endif

#endif /* CONFIG_PORTABILITY_H */
